#if 0
<--/****************************************
Automatic Performance Tuning for DGEMV -T
2015年  4月 14日 火曜日 03:42:24 JST
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-580
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="gauss.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-580";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(16)
#endif
#if !defined(scalar_t)
#define scalar_t	double
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_DGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_17	1
#define	KERNEL_5	1
#define	KERNEL_18	1
#define	KERNEL_19	1
#define	KERNEL_7	1
#define	KERNEL_12	1
#define	KERNEL_0	1
#define	KERNEL_14	1
#define	KERNEL_16	1
#define	KERNEL_3	1

if ( n >= 1 && n < 430 ) {
	BLK = 7;
} else
if ( n >= 430 && n < 512 ) {
	BLK = 5;
} else
if ( n >= 512 && n < 518 ) {
	BLK = 7;
} else
if ( n >= 518 && n < 578 ) {
	BLK = 19;
} else
if ( n >= 578 && n < 768 ) {
	BLK = 16;
} else
if ( n >= 768 && n < 1016 ) {
	BLK = 19;
} else
if ( n >= 1016 && n < 1024 ) {
	BLK = 5;
} else
if ( n >= 1024 && n < 1080 ) {
	BLK = 12;
} else
if ( n >= 1080 && n < 1280 ) {
	BLK = 17;
} else
if ( n >= 1280 && n < 1526 ) {
	BLK = 14;
} else
if ( n >= 1526 && n < 1536 ) {
	BLK = 16;
} else
if ( n >= 1536 && n < 3019 ) {
	BLK = 0;
} else
if ( n >= 3019 && n < 3047 ) {
	BLK = 14;
} else
if ( n >= 3047 && n < 3072 ) {
	BLK = 18;
} else
if ( n >= 3072 && n < 3454 ) {
	BLK = 0;
} else
if ( n >= 3454 && n < 3461 ) {
	BLK = 14;
} else
if ( n >= 3461 && n < 3584 ) {
	BLK = 18;
} else
if ( n >= 3584 && n < 3792 ) {
	BLK = 0;
} else
if ( n >= 3792 && n < 3840 ) {
	BLK = 16;
} else
if ( n >= 3840 && n < 3872 ) {
	BLK = 0;
} else
if ( n >= 3872 && n < 4096 ) {
	BLK = 18;
} else
if ( n >= 4096 && n < 4224 ) {
	BLK = 3;
} else
if ( n >= 4224 && n < 4273 ) {
	BLK = 0;
} else
if ( n >= 4273 && n < 4279 ) {
	BLK = 3;
} else
if ( n >= 4279 && n < 4608 ) {
	BLK = 18;
} else
if ( n >= 4608 && n < 4962 ) {
	BLK = 3;
} else
if ( n >= 4962 && n < 5113 ) {
	BLK = 18;
} else
if ( n >= 5113 && n < 5120 ) {
	BLK = 5;
} else
if ( n >= 5120 && n < 5354 ) {
	BLK = 3;
} else
if ( n >= 5354 && n < 5376 ) {
	BLK = 16;
} else
if ( n >= 5376 && n < 5617 ) {
	BLK = 18;
} else
if ( n >= 5617 && n < 5632 ) {
	BLK = 5;
} else
if ( n >= 5632 && n < 5977 ) {
	BLK = 3;
} else
if ( n >= 5977 && n < 6120 ) {
	BLK = 18;
} else
if ( n >= 6120 && n < 6144 ) {
	BLK = 5;
} else
if ( n >= 6144 && n < 6528 ) {
	BLK = 3;
} else
if ( n >= 6528 && n < 6623 ) {
	BLK = 18;
} else
if ( n >= 6623 && n < 6656 ) {
	BLK = 5;
} else
if ( n >= 6656 && n < 6986 ) {
	BLK = 3;
} else
if ( n >= 6986 && n < 7125 ) {
	BLK = 18;
} else
if ( n >= 7125 && n < 7168 ) {
	BLK = 5;
} else
if ( n >= 7168 && n < 7633 ) {
	BLK = 3;
} else
if ( n >= 7633 && n < 7680 ) {
	BLK = 5;
} else
if ( n >= 7680 && n < 8064 ) {
	BLK = 3;
} else
if ( n >= 8064 && n < 8129 ) {
	BLK = 18;
} else
if ( n >= 8129 && n < 8192 ) {
	BLK = 5;
} else
if ( n >= 8192 && n < 8637 ) {
	BLK = 3;
} else
if ( n >= 8637 && n < 8704 ) {
	BLK = 5;
} else
if ( n >= 8704 && n < 9173 ) {
	BLK = 3;
} else
if ( n >= 9173 && n < 9216 ) {
	BLK = 5;
} else
if ( n >= 9216 && n < 9640 ) {
	BLK = 3;
} else
if ( n >= 9640 && n < 9728 ) {
	BLK = 5;
} else
if ( n >= 9728 && n < 10175 ) {
	BLK = 3;
} else
if ( n >= 10175 && n < 10240 ) {
	BLK = 5;
} else
if ( n >= 10240 && n < 10711 ) {
	BLK = 3;
} else
if ( n >= 10711 && n < 10752 ) {
	BLK = 5;
} else
if ( n >= 10752 && n < 11177 ) {
	BLK = 3;
} else
if ( n >= 11177 && n < 11264 ) {
	BLK = 5;
} else
if ( n >= 11264 && n < 11712 ) {
	BLK = 3;
} else
if ( n >= 11712 && n < 11776 ) {
	BLK = 5;
} else
if ( n >= 11776 && n < 12248 ) {
	BLK = 3;
} else
if ( n >= 12248 && n < 12288 ) {
	BLK = 5;
} else
if ( n >= 12288 && n < 12714 ) {
	BLK = 3;
} else
if ( n >= 12714 && n < 12800 ) {
	BLK = 5;
} else
if ( n >= 12800 && n < 13249 ) {
	BLK = 3;
} else
if ( n >= 13249 && n < 13312 ) {
	BLK = 5;
} else
if ( n >= 13312 && n < 13477 ) {
	BLK = 3;
} else
if ( n >= 13477 && n < 100000000 ) {
	BLK = 3;
}

#if 1
	int ii=BLK;
#define DGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
		GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
		( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		DGEMVT_KERNEL_ ( 192 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		DGEMVT_KERNEL_ ( 64 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		DGEMVT_KERNEL_ ( 64 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		DGEMVT_KERNEL_ ( 128 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		DGEMVT_KERNEL_ ( 64 , 3 , 4, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		DGEMVT_KERNEL_ ( 48 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		DGEMVT_KERNEL_ ( 96 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		DGEMVT_KERNEL_ ( 48 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		DGEMVT_KERNEL_ ( 96 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		DGEMVT_KERNEL_ ( 48 , 3 , 2, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		DGEMVT_KERNEL_ ( 48 , 2 , 8, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		DGEMVT_KERNEL_ ( 160 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		DGEMVT_KERNEL_ ( 96 , 3 , 2, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		DGEMVT_KERNEL_ ( 192 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		DGEMVT_KERNEL_ ( 96 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		DGEMVT_KERNEL_ ( 224 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		DGEMVT_KERNEL_ ( 32 , 3 , 2, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		DGEMVT_KERNEL_ ( 160 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		DGEMVT_KERNEL_ ( 96 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		DGEMVT_KERNEL_ ( 48 , 2 , 4, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

