#if 0
<--/****************************************
Automatic Performance Tuning for SGEMV -T
2015年  4月 14日 火曜日 04:58:32 JST
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-580
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="gauss.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-580";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(16)
#endif
#if !defined(scalar_t)
#define scalar_t	float
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_SGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_4	1
#define	KERNEL_18	1
#define	KERNEL_5	1
#define	KERNEL_19	1
#define	KERNEL_6	1
#define	KERNEL_7	1
#define	KERNEL_8	1
#define	KERNEL_9	1
#define	KERNEL_10	1
#define	KERNEL_0	1
#define	KERNEL_14	1
#define	KERNEL_2	1
#define	KERNEL_3	1
#define	KERNEL_16	1

if ( n >= 1 && n < 139 ) {
	BLK = 18;
} else
if ( n >= 139 && n < 768 ) {
	BLK = 8;
} else
if ( n >= 768 && n < 896 ) {
	BLK = 14;
} else
if ( n >= 896 && n < 1024 ) {
	BLK = 10;
} else
if ( n >= 1024 && n < 1082 ) {
	BLK = 2;
} else
if ( n >= 1082 && n < 1152 ) {
	BLK = 19;
} else
if ( n >= 1152 && n < 1536 ) {
	BLK = 18;
} else
if ( n >= 1536 && n < 2026 ) {
	BLK = 3;
} else
if ( n >= 2026 && n < 2048 ) {
	BLK = 14;
} else
if ( n >= 2048 && n < 2688 ) {
	BLK = 9;
} else
if ( n >= 2688 && n < 2801 ) {
	BLK = 5;
} else
if ( n >= 2801 && n < 3072 ) {
	BLK = 14;
} else
if ( n >= 3072 && n < 3267 ) {
	BLK = 16;
} else
if ( n >= 3267 && n < 3328 ) {
	BLK = 0;
} else
if ( n >= 3328 && n < 3528 ) {
	BLK = 6;
} else
if ( n >= 3528 && n < 3584 ) {
	BLK = 7;
} else
if ( n >= 3584 && n < 3788 ) {
	BLK = 5;
} else
if ( n >= 3788 && n < 3840 ) {
	BLK = 0;
} else
if ( n >= 3840 && n < 3939 ) {
	BLK = 6;
} else
if ( n >= 3939 && n < 4096 ) {
	BLK = 14;
} else
if ( n >= 4096 && n < 4222 ) {
	BLK = 16;
} else
if ( n >= 4222 && n < 4352 ) {
	BLK = 0;
} else
if ( n >= 4352 && n < 4389 ) {
	BLK = 16;
} else
if ( n >= 4389 && n < 4499 ) {
	BLK = 6;
} else
if ( n >= 4499 && n < 4608 ) {
	BLK = 0;
} else
if ( n >= 4608 && n < 4699 ) {
	BLK = 16;
} else
if ( n >= 4699 && n < 4864 ) {
	BLK = 0;
} else
if ( n >= 4864 && n < 4938 ) {
	BLK = 16;
} else
if ( n >= 4938 && n < 5120 ) {
	BLK = 0;
} else
if ( n >= 5120 && n < 5176 ) {
	BLK = 16;
} else
if ( n >= 5176 && n < 5376 ) {
	BLK = 0;
} else
if ( n >= 5376 && n < 5415 ) {
	BLK = 16;
} else
if ( n >= 5415 && n < 7424 ) {
	BLK = 0;
} else
if ( n >= 7424 && n < 7458 ) {
	BLK = 4;
} else
if ( n >= 7458 && n < 7680 ) {
	BLK = 0;
} else
if ( n >= 7680 && n < 7716 ) {
	BLK = 4;
} else
if ( n >= 7716 && n < 7936 ) {
	BLK = 0;
} else
if ( n >= 7936 && n < 8000 ) {
	BLK = 4;
} else
if ( n >= 8000 && n < 8192 ) {
	BLK = 0;
} else
if ( n >= 8192 && n < 8314 ) {
	BLK = 4;
} else
if ( n >= 8314 && n < 8448 ) {
	BLK = 0;
} else
if ( n >= 8448 && n < 8572 ) {
	BLK = 4;
} else
if ( n >= 8572 && n < 8704 ) {
	BLK = 0;
} else
if ( n >= 8704 && n < 8829 ) {
	BLK = 4;
} else
if ( n >= 8829 && n < 8960 ) {
	BLK = 0;
} else
if ( n >= 8960 && n < 9086 ) {
	BLK = 4;
} else
if ( n >= 9086 && n < 9216 ) {
	BLK = 0;
} else
if ( n >= 9216 && n < 9343 ) {
	BLK = 4;
} else
if ( n >= 9343 && n < 9472 ) {
	BLK = 0;
} else
if ( n >= 9472 && n < 9600 ) {
	BLK = 4;
} else
if ( n >= 9600 && n < 9728 ) {
	BLK = 0;
} else
if ( n >= 9728 && n < 9920 ) {
	BLK = 4;
} else
if ( n >= 9920 && n < 9984 ) {
	BLK = 0;
} else
if ( n >= 9984 && n < 10196 ) {
	BLK = 4;
} else
if ( n >= 10196 && n < 10240 ) {
	BLK = 0;
} else
if ( n >= 10240 && n < 10453 ) {
	BLK = 4;
} else
if ( n >= 10453 && n < 10496 ) {
	BLK = 0;
} else
if ( n >= 10496 && n < 10710 ) {
	BLK = 4;
} else
if ( n >= 10710 && n < 10752 ) {
	BLK = 0;
} else
if ( n >= 10752 && n < 10966 ) {
	BLK = 4;
} else
if ( n >= 10966 && n < 11008 ) {
	BLK = 0;
} else
if ( n >= 11008 && n < 11222 ) {
	BLK = 4;
} else
if ( n >= 11222 && n < 11264 ) {
	BLK = 0;
} else
if ( n >= 11264 && n < 19060 ) {
	BLK = 4;
} else
if ( n >= 19060 && n < 100000000 ) {
	BLK = 4;
}

#if 1
	int ii=BLK;
        #define SGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
                GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
                ( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		SGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		SGEMVT_KERNEL_ ( 224 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		SGEMVT_KERNEL_ ( 64 , 3 , 4, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		SGEMVT_KERNEL_ ( 32 , 4 , 4, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		SGEMVT_KERNEL_ ( 256 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		SGEMVT_KERNEL_ ( 96 , 3 , 4, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		SGEMVT_KERNEL_ ( 128 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		SGEMVT_KERNEL_ ( 96 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		SGEMVT_KERNEL_ ( 64 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		SGEMVT_KERNEL_ ( 32 , 3 , 7, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		SGEMVT_KERNEL_ ( 32 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		SGEMVT_KERNEL_ ( 64 , 3 , 3, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		SGEMVT_KERNEL_ ( 128 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		SGEMVT_KERNEL_ ( 224 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		SGEMVT_KERNEL_ ( 64 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		SGEMVT_KERNEL_ ( 192 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		SGEMVT_KERNEL_ ( 192 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		SGEMVT_KERNEL_ ( 96 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		SGEMVT_KERNEL_ ( 32 , 3 , 4, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		SGEMVT_KERNEL_ ( 32 , 3 , 3, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

