#if 0
<--/****************************************
Automatic Performance Tuning for SGEMV -T
2015年  4月 22日 水曜日 02:51:51 JST
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-750-Ti
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="gauss.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-750-Ti";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(5)
#endif
#if !defined(scalar_t)
#define scalar_t	float
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_SGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_4	1
#define	KERNEL_18	1
#define	KERNEL_5	1
#define	KERNEL_6	1
#define	KERNEL_9	1
#define	KERNEL_0	1
#define	KERNEL_1	1
#define	KERNEL_15	1
#define	KERNEL_3	1

if ( n >= 1 && n < 4 ) {
	BLK = 6;
} else
if ( n >= 4 && n < 5 ) {
	BLK = 18;
} else
if ( n >= 5 && n < 32 ) {
	BLK = 15;
} else
if ( n >= 32 && n < 126 ) {
	BLK = 5;
} else
if ( n >= 126 && n < 134 ) {
	BLK = 15;
} else
if ( n >= 134 && n < 165 ) {
	BLK = 9;
} else
if ( n >= 165 && n < 174 ) {
	BLK = 18;
} else
if ( n >= 174 && n < 1407 ) {
	BLK = 6;
} else
if ( n >= 1407 && n < 1576 ) {
	BLK = 4;
} else
if ( n >= 1576 && n < 1600 ) {
	BLK = 1;
} else
if ( n >= 1600 && n < 2161 ) {
	BLK = 6;
} else
if ( n >= 2161 && n < 2258 ) {
	BLK = 0;
} else
if ( n >= 2258 && n < 2276 ) {
	BLK = 4;
} else
if ( n >= 2276 && n < 2300 ) {
	BLK = 1;
} else
if ( n >= 2300 && n < 2375 ) {
	BLK = 0;
} else
if ( n >= 2375 && n < 2384 ) {
	BLK = 4;
} else
if ( n >= 2384 && n < 2400 ) {
	BLK = 1;
} else
if ( n >= 2400 && n < 7667 ) {
	BLK = 0;
} else
if ( n >= 7667 && n < 7700 ) {
	BLK = 3;
} else
if ( n >= 7700 && n < 7766 ) {
	BLK = 0;
} else
if ( n >= 7766 && n < 7800 ) {
	BLK = 3;
} else
if ( n >= 7800 && n < 7864 ) {
	BLK = 0;
} else
if ( n >= 7864 && n < 7900 ) {
	BLK = 3;
} else
if ( n >= 7900 && n < 7962 ) {
	BLK = 0;
} else
if ( n >= 7962 && n < 8000 ) {
	BLK = 3;
} else
if ( n >= 8000 && n < 8060 ) {
	BLK = 0;
} else
if ( n >= 8060 && n < 8100 ) {
	BLK = 3;
} else
if ( n >= 8100 && n < 8158 ) {
	BLK = 0;
} else
if ( n >= 8158 && n < 8200 ) {
	BLK = 3;
} else
if ( n >= 8200 && n < 8256 ) {
	BLK = 0;
} else
if ( n >= 8256 && n < 8300 ) {
	BLK = 3;
} else
if ( n >= 8300 && n < 8355 ) {
	BLK = 0;
} else
if ( n >= 8355 && n < 8400 ) {
	BLK = 3;
} else
if ( n >= 8400 && n < 8453 ) {
	BLK = 0;
} else
if ( n >= 8453 && n < 8500 ) {
	BLK = 3;
} else
if ( n >= 8500 && n < 8551 ) {
	BLK = 0;
} else
if ( n >= 8551 && n < 8600 ) {
	BLK = 3;
} else
if ( n >= 8600 && n < 8649 ) {
	BLK = 0;
} else
if ( n >= 8649 && n < 8700 ) {
	BLK = 3;
} else
if ( n >= 8700 && n < 8747 ) {
	BLK = 0;
} else
if ( n >= 8747 && n < 8800 ) {
	BLK = 3;
} else
if ( n >= 8800 && n < 8845 ) {
	BLK = 0;
} else
if ( n >= 8845 && n < 8900 ) {
	BLK = 3;
} else
if ( n >= 8900 && n < 8943 ) {
	BLK = 0;
} else
if ( n >= 8943 && n < 9000 ) {
	BLK = 3;
} else
if ( n >= 9000 && n < 9042 ) {
	BLK = 0;
} else
if ( n >= 9042 && n < 9100 ) {
	BLK = 3;
} else
if ( n >= 9100 && n < 9140 ) {
	BLK = 0;
} else
if ( n >= 9140 && n < 9200 ) {
	BLK = 3;
} else
if ( n >= 9200 && n < 9238 ) {
	BLK = 0;
} else
if ( n >= 9238 && n < 9300 ) {
	BLK = 3;
} else
if ( n >= 9300 && n < 9336 ) {
	BLK = 0;
} else
if ( n >= 9336 && n < 9400 ) {
	BLK = 3;
} else
if ( n >= 9400 && n < 9434 ) {
	BLK = 0;
} else
if ( n >= 9434 && n < 22007 ) {
	BLK = 3;
} else
if ( n >= 22007 && n < 100000000 ) {
	BLK = 3;
}

#if 1
	int ii=BLK;
        #define SGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
                GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
                ( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		SGEMVT_KERNEL_ ( 384 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		SGEMVT_KERNEL_ ( 320 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		SGEMVT_KERNEL_ ( 384 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		SGEMVT_KERNEL_ ( 352 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		SGEMVT_KERNEL_ ( 288 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		SGEMVT_KERNEL_ ( 160 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		SGEMVT_KERNEL_ ( 32 , 4 , 8, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		SGEMVT_KERNEL_ ( 96 , 2 , 7, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		SGEMVT_KERNEL_ ( 32 , 11 , 4, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		SGEMVT_KERNEL_ ( 32 , 9 , 4, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		SGEMVT_KERNEL_ ( 32 , 7 , 6, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		SGEMVT_KERNEL_ ( 64 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		SGEMVT_KERNEL_ ( 352 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		SGEMVT_KERNEL_ ( 320 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		SGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		SGEMVT_KERNEL_ ( 96 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		SGEMVT_KERNEL_ ( 32 , 4 , 4, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		SGEMVT_KERNEL_ ( 96 , 2 , 5, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		SGEMVT_KERNEL_ ( 32 , 8 , 8, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		SGEMVT_KERNEL_ ( 32 , 8 , 5, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

