#if 0
<--/****************************************
Automatic Performance Tuning for SGEMV -T
2015年  4月 21日 火曜日 01:41:46 JST
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-750-Ti
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="gauss.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-750-Ti";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(5)
#endif
#if !defined(scalar_t)
#define scalar_t	float
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_SGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_4	1
#define	KERNEL_5	1
#define	KERNEL_18	1
#define	KERNEL_6	1
#define	KERNEL_7	1
#define	KERNEL_8	1
#define	KERNEL_10	1
#define	KERNEL_12	1
#define	KERNEL_0	1
#define	KERNEL_14	1
#define	KERNEL_2	1
#define	KERNEL_3	1

if ( n >= 1 && n < 306 ) {
	BLK = 8;
} else
if ( n >= 306 && n < 320 ) {
	BLK = 7;
} else
if ( n >= 320 && n < 401 ) {
	BLK = 5;
} else
if ( n >= 401 && n < 420 ) {
	BLK = 6;
} else
if ( n >= 420 && n < 967 ) {
	BLK = 7;
} else
if ( n >= 967 && n < 1200 ) {
	BLK = 8;
} else
if ( n >= 1200 && n < 1280 ) {
	BLK = 7;
} else
if ( n >= 1280 && n < 1357 ) {
	BLK = 5;
} else
if ( n >= 1357 && n < 1400 ) {
	BLK = 3;
} else
if ( n >= 1400 && n < 1402 ) {
	BLK = 12;
} else
if ( n >= 1402 && n < 1440 ) {
	BLK = 2;
} else
if ( n >= 1440 && n < 1489 ) {
	BLK = 14;
} else
if ( n >= 1489 && n < 1500 ) {
	BLK = 3;
} else
if ( n >= 1500 && n < 1515 ) {
	BLK = 0;
} else
if ( n >= 1515 && n < 1560 ) {
	BLK = 2;
} else
if ( n >= 1560 && n < 1846 ) {
	BLK = 0;
} else
if ( n >= 1846 && n < 2400 ) {
	BLK = 18;
} else
if ( n >= 2400 && n < 2520 ) {
	BLK = 10;
} else
if ( n >= 2520 && n < 8850 ) {
	BLK = 0;
} else
if ( n >= 8850 && n < 8883 ) {
	BLK = 4;
} else
if ( n >= 8883 && n < 8925 ) {
	BLK = 0;
} else
if ( n >= 8925 && n < 8958 ) {
	BLK = 4;
} else
if ( n >= 8958 && n < 9000 ) {
	BLK = 0;
} else
if ( n >= 9000 && n < 9033 ) {
	BLK = 4;
} else
if ( n >= 9033 && n < 9075 ) {
	BLK = 0;
} else
if ( n >= 9075 && n < 9109 ) {
	BLK = 4;
} else
if ( n >= 9109 && n < 9150 ) {
	BLK = 0;
} else
if ( n >= 9150 && n < 9188 ) {
	BLK = 4;
} else
if ( n >= 9188 && n < 9225 ) {
	BLK = 0;
} else
if ( n >= 9225 && n < 9264 ) {
	BLK = 4;
} else
if ( n >= 9264 && n < 9300 ) {
	BLK = 0;
} else
if ( n >= 9300 && n < 9339 ) {
	BLK = 4;
} else
if ( n >= 9339 && n < 9375 ) {
	BLK = 0;
} else
if ( n >= 9375 && n < 9414 ) {
	BLK = 4;
} else
if ( n >= 9414 && n < 9450 ) {
	BLK = 0;
} else
if ( n >= 9450 && n < 22007 ) {
	BLK = 4;
} else
if ( n >= 22007 && n < 100000000 ) {
	BLK = 4;
}

#if 1
	int ii=BLK;
        #define SGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
                GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
                ( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		SGEMVT_KERNEL_ ( 384 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		SGEMVT_KERNEL_ ( 352 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		SGEMVT_KERNEL_ ( 320 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		SGEMVT_KERNEL_ ( 288 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		SGEMVT_KERNEL_ ( 384 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		SGEMVT_KERNEL_ ( 128 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		SGEMVT_KERNEL_ ( 96 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		SGEMVT_KERNEL_ ( 32 , 4 , 4, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		SGEMVT_KERNEL_ ( 32 , 5 , 4, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		SGEMVT_KERNEL_ ( 192 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		SGEMVT_KERNEL_ ( 32 , 3 , 8, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		SGEMVT_KERNEL_ ( 64 , 2 , 5, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		SGEMVT_KERNEL_ ( 224 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		SGEMVT_KERNEL_ ( 352 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		SGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		SGEMVT_KERNEL_ ( 32 , 11 , 4, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		SGEMVT_KERNEL_ ( 320 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		SGEMVT_KERNEL_ ( 32 , 7 , 8, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		SGEMVT_KERNEL_ ( 32 , 5 , 8, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		SGEMVT_KERNEL_ ( 64 , 4 , 5, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

