#if 0
<--/****************************************
Automatic Performance Tuning for DGEMV -T
2015年  4月 26日 日曜日 02:20:46 JST
Host on laplace.aics27.riken.jp
Device is GeForce-GTX-980
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="laplace.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-980";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(16)
#endif
#if !defined(scalar_t)
#define scalar_t	double
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_DGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_4	1
#define	KERNEL_18	1
#define	KERNEL_5	1
#define	KERNEL_19	1
#define	KERNEL_6	1
#define	KERNEL_7	1
#define	KERNEL_12	1
#define	KERNEL_0	1
#define	KERNEL_1	1
#define	KERNEL_2	1
#define	KERNEL_3	1

if ( n >= 1 && n < 399 ) {
	BLK = 18;
} else
if ( n >= 399 && n < 912 ) {
	BLK = 7;
} else
if ( n >= 912 && n < 957 ) {
	BLK = 3;
} else
if ( n >= 957 && n < 960 ) {
	BLK = 19;
} else
if ( n >= 960 && n < 1033 ) {
	BLK = 7;
} else
if ( n >= 1033 && n < 1152 ) {
	BLK = 6;
} else
if ( n >= 1152 && n < 1280 ) {
	BLK = 3;
} else
if ( n >= 1280 && n < 1415 ) {
	BLK = 5;
} else
if ( n >= 1415 && n < 1440 ) {
	BLK = 19;
} else
if ( n >= 1440 && n < 1536 ) {
	BLK = 6;
} else
if ( n >= 1536 && n < 1600 ) {
	BLK = 3;
} else
if ( n >= 1600 && n < 1920 ) {
	BLK = 18;
} else
if ( n >= 1920 && n < 2016 ) {
	BLK = 5;
} else
if ( n >= 2016 && n < 2048 ) {
	BLK = 1;
} else
if ( n >= 2048 && n < 2113 ) {
	BLK = 2;
} else
if ( n >= 2113 && n < 2186 ) {
	BLK = 1;
} else
if ( n >= 2186 && n < 2304 ) {
	BLK = 5;
} else
if ( n >= 2304 && n < 2378 ) {
	BLK = 2;
} else
if ( n >= 2378 && n < 2560 ) {
	BLK = 1;
} else
if ( n >= 2560 && n < 2592 ) {
	BLK = 5;
} else
if ( n >= 2592 && n < 2642 ) {
	BLK = 2;
} else
if ( n >= 2642 && n < 2688 ) {
	BLK = 1;
} else
if ( n >= 2688 && n < 2719 ) {
	BLK = 12;
} else
if ( n >= 2719 && n < 2737 ) {
	BLK = 2;
} else
if ( n >= 2737 && n < 2816 ) {
	BLK = 1;
} else
if ( n >= 2816 && n < 2880 ) {
	BLK = 5;
} else
if ( n >= 2880 && n < 2925 ) {
	BLK = 12;
} else
if ( n >= 2925 && n < 3000 ) {
	BLK = 2;
} else
if ( n >= 3000 && n < 3072 ) {
	BLK = 1;
} else
if ( n >= 3072 && n < 3136 ) {
	BLK = 12;
} else
if ( n >= 3136 && n < 3262 ) {
	BLK = 2;
} else
if ( n >= 3262 && n < 3264 ) {
	BLK = 1;
} else
if ( n >= 3264 && n < 3360 ) {
	BLK = 12;
} else
if ( n >= 3360 && n < 3456 ) {
	BLK = 2;
} else
if ( n >= 3456 && n < 3579 ) {
	BLK = 12;
} else
if ( n >= 3579 && n < 3584 ) {
	BLK = 1;
} else
if ( n >= 3584 && n < 3648 ) {
	BLK = 2;
} else
if ( n >= 3648 && n < 3789 ) {
	BLK = 12;
} else
if ( n >= 3789 && n < 3808 ) {
	BLK = 4;
} else
if ( n >= 3808 && n < 3840 ) {
	BLK = 2;
} else
if ( n >= 3840 && n < 3970 ) {
	BLK = 12;
} else
if ( n >= 3970 && n < 4032 ) {
	BLK = 4;
} else
if ( n >= 4032 && n < 4152 ) {
	BLK = 12;
} else
if ( n >= 4152 && n < 4224 ) {
	BLK = 0;
} else
if ( n >= 4224 && n < 4323 ) {
	BLK = 12;
} else
if ( n >= 4323 && n < 4416 ) {
	BLK = 0;
} else
if ( n >= 4416 && n < 4495 ) {
	BLK = 12;
} else
if ( n >= 4495 && n < 4608 ) {
	BLK = 0;
} else
if ( n >= 4608 && n < 4666 ) {
	BLK = 12;
} else
if ( n >= 4666 && n < 4800 ) {
	BLK = 0;
} else
if ( n >= 4800 && n < 4838 ) {
	BLK = 12;
} else
if ( n >= 4838 && n < 22010 ) {
	BLK = 0;
} else
if ( n >= 22010 && n < 100000000 ) {
	BLK = 0;
}

#if 1
	int ii=BLK;
#define DGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
		GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
		( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		DGEMVT_KERNEL_ ( 384 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		DGEMVT_KERNEL_ ( 256 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		DGEMVT_KERNEL_ ( 288 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		DGEMVT_KERNEL_ ( 192 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		DGEMVT_KERNEL_ ( 352 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		DGEMVT_KERNEL_ ( 224 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		DGEMVT_KERNEL_ ( 160 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		DGEMVT_KERNEL_ ( 32 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		DGEMVT_KERNEL_ ( 96 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		DGEMVT_KERNEL_ ( 32 , 10 , 2, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		DGEMVT_KERNEL_ ( 16 , 8 , 2, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		DGEMVT_KERNEL_ ( 16 , 17 , 2, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		DGEMVT_KERNEL_ ( 320 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		DGEMVT_KERNEL_ ( 160 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		DGEMVT_KERNEL_ ( 32 , 8 , 2, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		DGEMVT_KERNEL_ ( 16 , 18 , 2, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		DGEMVT_KERNEL_ ( 128 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		DGEMVT_KERNEL_ ( 16 , 16 , 2, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		DGEMVT_KERNEL_ ( 32 , 5 , 2, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		DGEMVT_KERNEL_ ( 128 , 3 , 2, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

