#if 0
<--/****************************************
Automatic Performance Tuning for SGEMV -T
2015年  4月 26日 日曜日 05:21:55 JST
Host on laplace.aics27.riken.jp
Device is GeForce-GTX-980
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="laplace.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-980";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(16)
#endif
#if !defined(scalar_t)
#define scalar_t	float
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_SGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_4	1
#define	KERNEL_17	1
#define	KERNEL_5	1
#define	KERNEL_6	1
#define	KERNEL_19	1
#define	KERNEL_8	1
#define	KERNEL_9	1
#define	KERNEL_11	1
#define	KERNEL_12	1
#define	KERNEL_13	1
#define	KERNEL_1	1
#define	KERNEL_16	1

if ( n >= 1 && n < 320 ) {
	BLK = 9;
} else
if ( n >= 320 && n < 352 ) {
	BLK = 4;
} else
if ( n >= 352 && n < 576 ) {
	BLK = 8;
} else
if ( n >= 576 && n < 960 ) {
	BLK = 16;
} else
if ( n >= 960 && n < 1008 ) {
	BLK = 12;
} else
if ( n >= 1008 && n < 1009 ) {
	BLK = 9;
} else
if ( n >= 1009 && n < 1152 ) {
	BLK = 8;
} else
if ( n >= 1152 && n < 1437 ) {
	BLK = 9;
} else
if ( n >= 1437 && n < 1680 ) {
	BLK = 13;
} else
if ( n >= 1680 && n < 1900 ) {
	BLK = 9;
} else
if ( n >= 1900 && n < 1920 ) {
	BLK = 17;
} else
if ( n >= 1920 && n < 2016 ) {
	BLK = 11;
} else
if ( n >= 2016 && n < 2181 ) {
	BLK = 1;
} else
if ( n >= 2181 && n < 2240 ) {
	BLK = 4;
} else
if ( n >= 2240 && n < 2491 ) {
	BLK = 1;
} else
if ( n >= 2491 && n < 2560 ) {
	BLK = 4;
} else
if ( n >= 2560 && n < 2799 ) {
	BLK = 1;
} else
if ( n >= 2799 && n < 2880 ) {
	BLK = 4;
} else
if ( n >= 2880 && n < 3106 ) {
	BLK = 1;
} else
if ( n >= 3106 && n < 3200 ) {
	BLK = 4;
} else
if ( n >= 3200 && n < 3412 ) {
	BLK = 1;
} else
if ( n >= 3412 && n < 3520 ) {
	BLK = 4;
} else
if ( n >= 3520 && n < 3717 ) {
	BLK = 1;
} else
if ( n >= 3717 && n < 3840 ) {
	BLK = 4;
} else
if ( n >= 3840 && n < 4022 ) {
	BLK = 1;
} else
if ( n >= 4022 && n < 4080 ) {
	BLK = 4;
} else
if ( n >= 4080 && n < 4160 ) {
	BLK = 6;
} else
if ( n >= 4160 && n < 4320 ) {
	BLK = 1;
} else
if ( n >= 4320 && n < 4417 ) {
	BLK = 6;
} else
if ( n >= 4417 && n < 4469 ) {
	BLK = 4;
} else
if ( n >= 4469 && n < 4480 ) {
	BLK = 19;
} else
if ( n >= 4480 && n < 4616 ) {
	BLK = 1;
} else
if ( n >= 4616 && n < 4644 ) {
	BLK = 6;
} else
if ( n >= 4644 && n < 4685 ) {
	BLK = 4;
} else
if ( n >= 4685 && n < 4800 ) {
	BLK = 19;
} else
if ( n >= 4800 && n < 4912 ) {
	BLK = 1;
} else
if ( n >= 4912 && n < 5040 ) {
	BLK = 19;
} else
if ( n >= 5040 && n < 5112 ) {
	BLK = 6;
} else
if ( n >= 5112 && n < 5120 ) {
	BLK = 19;
} else
if ( n >= 5120 && n < 5157 ) {
	BLK = 1;
} else
if ( n >= 5157 && n < 5280 ) {
	BLK = 19;
} else
if ( n >= 5280 && n < 5329 ) {
	BLK = 6;
} else
if ( n >= 5329 && n < 7951 ) {
	BLK = 19;
} else
if ( n >= 7951 && n < 8000 ) {
	BLK = 5;
} else
if ( n >= 8000 && n < 8355 ) {
	BLK = 19;
} else
if ( n >= 8355 && n < 8400 ) {
	BLK = 5;
} else
if ( n >= 8400 && n < 8726 ) {
	BLK = 19;
} else
if ( n >= 8726 && n < 8800 ) {
	BLK = 5;
} else
if ( n >= 8800 && n < 9120 ) {
	BLK = 19;
} else
if ( n >= 9120 && n < 9200 ) {
	BLK = 5;
} else
if ( n >= 9200 && n < 9502 ) {
	BLK = 19;
} else
if ( n >= 9502 && n < 9600 ) {
	BLK = 5;
} else
if ( n >= 9600 && n < 9872 ) {
	BLK = 19;
} else
if ( n >= 9872 && n < 10000 ) {
	BLK = 5;
} else
if ( n >= 10000 && n < 10277 ) {
	BLK = 19;
} else
if ( n >= 10277 && n < 10400 ) {
	BLK = 5;
} else
if ( n >= 10400 && n < 10647 ) {
	BLK = 19;
} else
if ( n >= 10647 && n < 10800 ) {
	BLK = 5;
} else
if ( n >= 10800 && n < 11040 ) {
	BLK = 19;
} else
if ( n >= 11040 && n < 11200 ) {
	BLK = 5;
} else
if ( n >= 11200 && n < 11422 ) {
	BLK = 19;
} else
if ( n >= 11422 && n < 11600 ) {
	BLK = 5;
} else
if ( n >= 11600 && n < 11793 ) {
	BLK = 19;
} else
if ( n >= 11793 && n < 12000 ) {
	BLK = 5;
} else
if ( n >= 12000 && n < 12197 ) {
	BLK = 19;
} else
if ( n >= 12197 && n < 12400 ) {
	BLK = 5;
} else
if ( n >= 12400 && n < 12568 ) {
	BLK = 19;
} else
if ( n >= 12568 && n < 12800 ) {
	BLK = 5;
} else
if ( n >= 12800 && n < 12960 ) {
	BLK = 19;
} else
if ( n >= 12960 && n < 13200 ) {
	BLK = 5;
} else
if ( n >= 13200 && n < 13342 ) {
	BLK = 19;
} else
if ( n >= 13342 && n < 13600 ) {
	BLK = 5;
} else
if ( n >= 13600 && n < 13713 ) {
	BLK = 19;
} else
if ( n >= 13713 && n < 14000 ) {
	BLK = 5;
} else
if ( n >= 14000 && n < 14117 ) {
	BLK = 19;
} else
if ( n >= 14117 && n < 14400 ) {
	BLK = 5;
} else
if ( n >= 14400 && n < 14487 ) {
	BLK = 19;
} else
if ( n >= 14487 && n < 14800 ) {
	BLK = 5;
} else
if ( n >= 14800 && n < 14880 ) {
	BLK = 19;
} else
if ( n >= 14880 && n < 15200 ) {
	BLK = 5;
} else
if ( n >= 15200 && n < 15262 ) {
	BLK = 19;
} else
if ( n >= 15262 && n < 16000 ) {
	BLK = 5;
} else
if ( n >= 16000 && n < 16036 ) {
	BLK = 19;
} else
if ( n >= 16036 && n < 31128 ) {
	BLK = 5;
} else
if ( n >= 31128 && n < 100000000 ) {
	BLK = 5;
}

#if 1
	int ii=BLK;
        #define SGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
                GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
                ( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		SGEMVT_KERNEL_ ( 384 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		SGEMVT_KERNEL_ ( 384 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		SGEMVT_KERNEL_ ( 320 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		SGEMVT_KERNEL_ ( 320 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		SGEMVT_KERNEL_ ( 352 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		SGEMVT_KERNEL_ ( 384 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		SGEMVT_KERNEL_ ( 384 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		SGEMVT_KERNEL_ ( 320 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		SGEMVT_KERNEL_ ( 224 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		SGEMVT_KERNEL_ ( 64 , 3 , 4, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		SGEMVT_KERNEL_ ( 224 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		SGEMVT_KERNEL_ ( 32 , 9 , 2, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		SGEMVT_KERNEL_ ( 96 , 3 , 3, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		SGEMVT_KERNEL_ ( 96 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		SGEMVT_KERNEL_ ( 32 , 8 , 4, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		SGEMVT_KERNEL_ ( 32 , 3 , 4, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		SGEMVT_KERNEL_ ( 64 , 3 , 2, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		SGEMVT_KERNEL_ ( 32 , 10 , 2, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		SGEMVT_KERNEL_ ( 352 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		SGEMVT_KERNEL_ ( 352 , 1 , 3, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

