#if 0
<--/****************************************
Automatic Performance Tuning for DGEMV -T
2015年  4月 10日 金曜日 22:04:22 JST
Host on pascal.aics27.riken.jp
Device is Tesla-K20c
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="pascal.aics27.riken.jp";
char* _AT_tuned_device="Tesla-K20c";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(13)
#endif
#if !defined(scalar_t)
#define scalar_t	double
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_DGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_17	1
#define	KERNEL_4	1
#define	KERNEL_5	1
#define	KERNEL_19	1
#define	KERNEL_8	1
#define	KERNEL_9	1
#define	KERNEL_0	1
#define	KERNEL_1	1
#define	KERNEL_14	1
#define	KERNEL_16	1

if ( n >= 1 && n < 257 ) {
	BLK = 8;
} else
if ( n >= 257 && n < 491 ) {
	BLK = 9;
} else
if ( n >= 491 && n < 676 ) {
	BLK = 17;
} else
if ( n >= 676 && n < 1040 ) {
	BLK = 9;
} else
if ( n >= 1040 && n < 1352 ) {
	BLK = 17;
} else
if ( n >= 1352 && n < 1404 ) {
	BLK = 4;
} else
if ( n >= 1404 && n < 1414 ) {
	BLK = 0;
} else
if ( n >= 1414 && n < 1432 ) {
	BLK = 5;
} else
if ( n >= 1432 && n < 1560 ) {
	BLK = 8;
} else
if ( n >= 1560 && n < 1658 ) {
	BLK = 0;
} else
if ( n >= 1658 && n < 1716 ) {
	BLK = 1;
} else
if ( n >= 1716 && n < 1781 ) {
	BLK = 0;
} else
if ( n >= 1781 && n < 1820 ) {
	BLK = 1;
} else
if ( n >= 1820 && n < 1872 ) {
	BLK = 17;
} else
if ( n >= 1872 && n < 1915 ) {
	BLK = 0;
} else
if ( n >= 1915 && n < 2028 ) {
	BLK = 17;
} else
if ( n >= 2028 && n < 2111 ) {
	BLK = 0;
} else
if ( n >= 2111 && n < 2184 ) {
	BLK = 16;
} else
if ( n >= 2184 && n < 2248 ) {
	BLK = 0;
} else
if ( n >= 2248 && n < 2340 ) {
	BLK = 16;
} else
if ( n >= 2340 && n < 2384 ) {
	BLK = 0;
} else
if ( n >= 2384 && n < 3042 ) {
	BLK = 16;
} else
if ( n >= 3042 && n < 6976 ) {
	BLK = 0;
} else
if ( n >= 6976 && n < 7020 ) {
	BLK = 14;
} else
if ( n >= 7020 && n < 7131 ) {
	BLK = 0;
} else
if ( n >= 7131 && n < 7176 ) {
	BLK = 14;
} else
if ( n >= 7176 && n < 7285 ) {
	BLK = 0;
} else
if ( n >= 7285 && n < 7332 ) {
	BLK = 14;
} else
if ( n >= 7332 && n < 7440 ) {
	BLK = 0;
} else
if ( n >= 7440 && n < 7488 ) {
	BLK = 14;
} else
if ( n >= 7488 && n < 7574 ) {
	BLK = 0;
} else
if ( n >= 7574 && n < 7644 ) {
	BLK = 14;
} else
if ( n >= 7644 && n < 7729 ) {
	BLK = 0;
} else
if ( n >= 7729 && n < 7800 ) {
	BLK = 14;
} else
if ( n >= 7800 && n < 7884 ) {
	BLK = 0;
} else
if ( n >= 7884 && n < 7956 ) {
	BLK = 14;
} else
if ( n >= 7956 && n < 8038 ) {
	BLK = 0;
} else
if ( n >= 8038 && n < 8112 ) {
	BLK = 14;
} else
if ( n >= 8112 && n < 8193 ) {
	BLK = 0;
} else
if ( n >= 8193 && n < 8268 ) {
	BLK = 14;
} else
if ( n >= 8268 && n < 8327 ) {
	BLK = 0;
} else
if ( n >= 8327 && n < 8424 ) {
	BLK = 14;
} else
if ( n >= 8424 && n < 8482 ) {
	BLK = 0;
} else
if ( n >= 8482 && n < 8580 ) {
	BLK = 14;
} else
if ( n >= 8580 && n < 8637 ) {
	BLK = 0;
} else
if ( n >= 8637 && n < 8736 ) {
	BLK = 14;
} else
if ( n >= 8736 && n < 8791 ) {
	BLK = 0;
} else
if ( n >= 8791 && n < 8892 ) {
	BLK = 14;
} else
if ( n >= 8892 && n < 8926 ) {
	BLK = 0;
} else
if ( n >= 8926 && n < 11147 ) {
	BLK = 14;
} else
if ( n >= 11147 && n < 11180 ) {
	BLK = 19;
} else
if ( n >= 11180 && n < 11393 ) {
	BLK = 14;
} else
if ( n >= 11393 && n < 11440 ) {
	BLK = 19;
} else
if ( n >= 11440 && n < 11640 ) {
	BLK = 14;
} else
if ( n >= 11640 && n < 11700 ) {
	BLK = 19;
} else
if ( n >= 11700 && n < 11886 ) {
	BLK = 14;
} else
if ( n >= 11886 && n < 11960 ) {
	BLK = 19;
} else
if ( n >= 11960 && n < 12090 ) {
	BLK = 14;
} else
if ( n >= 12090 && n < 12220 ) {
	BLK = 19;
} else
if ( n >= 12220 && n < 12334 ) {
	BLK = 14;
} else
if ( n >= 12334 && n < 12480 ) {
	BLK = 19;
} else
if ( n >= 12480 && n < 12580 ) {
	BLK = 14;
} else
if ( n >= 12580 && n < 12740 ) {
	BLK = 19;
} else
if ( n >= 12740 && n < 12826 ) {
	BLK = 14;
} else
if ( n >= 12826 && n < 13000 ) {
	BLK = 19;
} else
if ( n >= 13000 && n < 13065 ) {
	BLK = 14;
} else
if ( n >= 13065 && n < 23827 ) {
	BLK = 19;
} else
if ( n >= 23827 && n < 100000000 ) {
	BLK = 19;
}

#if 1
	int ii=BLK;
#define DGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
		GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
		( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		DGEMVT_KERNEL_ ( 320 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		DGEMVT_KERNEL_ ( 288 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		DGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		DGEMVT_KERNEL_ ( 320 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		DGEMVT_KERNEL_ ( 128 , 1 , 6, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		DGEMVT_KERNEL_ ( 32 , 5 , 2, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		DGEMVT_KERNEL_ ( 96 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		DGEMVT_KERNEL_ ( 256 , 1 , 7, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		DGEMVT_KERNEL_ ( 32 , 10 , 3, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		DGEMVT_KERNEL_ ( 96 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		DGEMVT_KERNEL_ ( 32 , 5 , 4, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		DGEMVT_KERNEL_ ( 192 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		DGEMVT_KERNEL_ ( 64 , 3 , 5, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		DGEMVT_KERNEL_ ( 16 , 23 , 2, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		DGEMVT_KERNEL_ ( 288 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		DGEMVT_KERNEL_ ( 352 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		DGEMVT_KERNEL_ ( 16 , 13 , 2, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		DGEMVT_KERNEL_ ( 96 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		DGEMVT_KERNEL_ ( 320 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		DGEMVT_KERNEL_ ( 288 , 1 , 5, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

