#if 0
<--/****************************************
Automatic Performance Tuning for SGEMV -T
2015年  4月 11日 土曜日 02:56:26 JST
Host on pascal.aics27.riken.jp
Device is Tesla-K20c
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="pascal.aics27.riken.jp";
char* _AT_tuned_device="Tesla-K20c";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(13)
#endif
#if !defined(scalar_t)
#define scalar_t	float
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_SGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_17	1
#define	KERNEL_4	1
#define	KERNEL_5	1
#define	KERNEL_19	1
#define	KERNEL_6	1
#define	KERNEL_7	1
#define	KERNEL_8	1
#define	KERNEL_9	1
#define	KERNEL_10	1
#define	KERNEL_11	1
#define	KERNEL_13	1
#define	KERNEL_0	1
#define	KERNEL_1	1
#define	KERNEL_15	1
#define	KERNEL_2	1
#define	KERNEL_16	1
#define	KERNEL_3	1

if ( n >= 1 && n < 79 ) {
	BLK = 8;
} else
if ( n >= 79 && n < 151 ) {
	BLK = 9;
} else
if ( n >= 151 && n < 287 ) {
	BLK = 11;
} else
if ( n >= 287 && n < 520 ) {
	BLK = 5;
} else
if ( n >= 520 && n < 832 ) {
	BLK = 7;
} else
if ( n >= 832 && n < 1040 ) {
	BLK = 19;
} else
if ( n >= 1040 && n < 1173 ) {
	BLK = 16;
} else
if ( n >= 1173 && n < 1248 ) {
	BLK = 15;
} else
if ( n >= 1248 && n < 1331 ) {
	BLK = 9;
} else
if ( n >= 1331 && n < 1456 ) {
	BLK = 10;
} else
if ( n >= 1456 && n < 1620 ) {
	BLK = 9;
} else
if ( n >= 1620 && n < 1664 ) {
	BLK = 7;
} else
if ( n >= 1664 && n < 1750 ) {
	BLK = 6;
} else
if ( n >= 1750 && n < 1992 ) {
	BLK = 19;
} else
if ( n >= 1992 && n < 2340 ) {
	BLK = 8;
} else
if ( n >= 2340 && n < 2496 ) {
	BLK = 7;
} else
if ( n >= 2496 && n < 2860 ) {
	BLK = 17;
} else
if ( n >= 2860 && n < 3120 ) {
	BLK = 13;
} else
if ( n >= 3120 && n < 3328 ) {
	BLK = 9;
} else
if ( n >= 3328 && n < 3432 ) {
	BLK = 1;
} else
if ( n >= 3432 && n < 3441 ) {
	BLK = 3;
} else
if ( n >= 3441 && n < 3640 ) {
	BLK = 5;
} else
if ( n >= 3640 && n < 3744 ) {
	BLK = 15;
} else
if ( n >= 3744 && n < 4004 ) {
	BLK = 3;
} else
if ( n >= 4004 && n < 4056 ) {
	BLK = 1;
} else
if ( n >= 4056 && n < 4160 ) {
	BLK = 5;
} else
if ( n >= 4160 && n < 4368 ) {
	BLK = 3;
} else
if ( n >= 4368 && n < 4420 ) {
	BLK = 2;
} else
if ( n >= 4420 && n < 4576 ) {
	BLK = 4;
} else
if ( n >= 4576 && n < 4680 ) {
	BLK = 1;
} else
if ( n >= 4680 && n < 4732 ) {
	BLK = 3;
} else
if ( n >= 4732 && n < 4992 ) {
	BLK = 1;
} else
if ( n >= 4992 && n < 5096 ) {
	BLK = 3;
} else
if ( n >= 5096 && n < 5115 ) {
	BLK = 2;
} else
if ( n >= 5115 && n < 5138 ) {
	BLK = 1;
} else
if ( n >= 5138 && n < 5200 ) {
	BLK = 5;
} else
if ( n >= 5200 && n < 5304 ) {
	BLK = 1;
} else
if ( n >= 5304 && n < 5460 ) {
	BLK = 3;
} else
if ( n >= 5460 && n < 5616 ) {
	BLK = 1;
} else
if ( n >= 5616 && n < 5720 ) {
	BLK = 2;
} else
if ( n >= 5720 && n < 5824 ) {
	BLK = 3;
} else
if ( n >= 5824 && n < 5928 ) {
	BLK = 1;
} else
if ( n >= 5928 && n < 5980 ) {
	BLK = 2;
} else
if ( n >= 5980 && n < 6022 ) {
	BLK = 0;
} else
if ( n >= 6022 && n < 6240 ) {
	BLK = 1;
} else
if ( n >= 6240 && n < 6421 ) {
	BLK = 0;
} else
if ( n >= 6421 && n < 6552 ) {
	BLK = 1;
} else
if ( n >= 6552 && n < 6760 ) {
	BLK = 0;
} else
if ( n >= 6760 && n < 6864 ) {
	BLK = 1;
} else
if ( n >= 6864 && n < 7020 ) {
	BLK = 0;
} else
if ( n >= 7020 && n < 7176 ) {
	BLK = 1;
} else
if ( n >= 7176 && n < 7398 ) {
	BLK = 0;
} else
if ( n >= 7398 && n < 7488 ) {
	BLK = 1;
} else
if ( n >= 7488 && n < 8060 ) {
	BLK = 0;
} else
if ( n >= 8060 && n < 8112 ) {
	BLK = 1;
} else
if ( n >= 8112 && n < 8375 ) {
	BLK = 0;
} else
if ( n >= 8375 && n < 8424 ) {
	BLK = 1;
} else
if ( n >= 8424 && n < 33696 ) {
	BLK = 0;
} else
if ( n >= 33696 && n < 100000000 ) {
	BLK = 0;
}

#if 1
	int ii=BLK;
        #define SGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
                GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
                ( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		SGEMVT_KERNEL_ ( 352 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		SGEMVT_KERNEL_ ( 320 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		SGEMVT_KERNEL_ ( 384 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		SGEMVT_KERNEL_ ( 288 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		SGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		SGEMVT_KERNEL_ ( 192 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		SGEMVT_KERNEL_ ( 160 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		SGEMVT_KERNEL_ ( 96 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		SGEMVT_KERNEL_ ( 32 , 12 , 3, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		SGEMVT_KERNEL_ ( 64 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		SGEMVT_KERNEL_ ( 96 , 1 , 7, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		SGEMVT_KERNEL_ ( 224 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		SGEMVT_KERNEL_ ( 320 , 1 , 8, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		SGEMVT_KERNEL_ ( 32 , 6 , 4, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		SGEMVT_KERNEL_ ( 64 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		SGEMVT_KERNEL_ ( 96 , 2 , 8, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		SGEMVT_KERNEL_ ( 96 , 2 , 6, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		SGEMVT_KERNEL_ ( 32 , 11 , 4, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		SGEMVT_KERNEL_ ( 288 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		SGEMVT_KERNEL_ ( 96 , 2 , 4, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

